org.activiti.engine.history

## Interface HistoricProcessInstanceQuery

- All Superinterfaces:
    Query<HistoricProcessInstanceQuery,HistoricProcessInstance>

      public interface HistoricProcessInstanceQuery
      extends Query<HistoricProcessInstanceQuery,HistoricProcessInstance>

  Allows programmatic querying of `HistoricProcessInstance`s.
  Author:
    Tom Baeyens, Joram Barrez, Tijs Rademakers, Falko Menge

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `HistoricProcessInstanceQuery` | `deleted()` Only select historic process instances that are deleted.
    `HistoricProcessInstanceQuery` | `deploymentId(String deploymentId)` Only select historic process instances that are defined by a process definition with the given deployment identifier.
    `HistoricProcessInstanceQuery` | `deploymentIdIn(List<String> deploymentIds)` Only select historic process instances that are defined by a process definition with one of the given deployment identifiers.
    `HistoricProcessInstanceQuery` | `endOr()` End an OR statement.
    `HistoricProcessInstanceQuery` | `excludeSubprocesses(boolean excludeSubprocesses)` Exclude sub processes from the query result;
    `HistoricProcessInstanceQuery` | `finished()` Only select historic process instances that are completely finished.
    `HistoricProcessInstanceQuery` | `finishedAfter(Date date)` Only select historic process instances that were started after the given date.
    `HistoricProcessInstanceQuery` | `finishedBefore(Date date)` Only select historic process instances that were started before the given date.
    `HistoricProcessInstanceQuery` | `includeProcessVariables()` Include process variables in the process query result
    `HistoricProcessInstanceQuery` | `involvedUser(String userId)` Only select the historic process instances with which the user with the given id is involved.
    `HistoricProcessInstanceQuery` | `limitProcessInstanceVariables(Integer processInstanceVariablesLimit)` Limit process instance variables
    `HistoricProcessInstanceQuery` | `locale(String locale)` Localize historic process name and description to specified locale.
    `HistoricProcessInstanceQuery` | `notDeleted()` Only select historic process instance that are not deleted.
    `HistoricProcessInstanceQuery` | `or()` Begin an OR statement.
    `HistoricProcessInstanceQuery` | `orderByProcessDefinitionId()` Order by the process definition id (needs to be followed by `Query.asc()` or `Query.desc()`).
    `HistoricProcessInstanceQuery` | `orderByProcessInstanceBusinessKey()` Order by the business key (needs to be followed by `Query.asc()` or `Query.desc()`).
    `HistoricProcessInstanceQuery` | `orderByProcessInstanceDuration()` Order by the duration of the process instance (needs to be followed by `Query.asc()` or `Query.desc()`).
    `HistoricProcessInstanceQuery` | `orderByProcessInstanceEndTime()` Order by the end time (needs to be followed by `Query.asc()` or `Query.desc()`).
    `HistoricProcessInstanceQuery` | `orderByProcessInstanceId()` Order by the process instance id (needs to be followed by `Query.asc()` or `Query.desc()`).
    `HistoricProcessInstanceQuery` | `orderByProcessInstanceStartTime()` Order by the start time (needs to be followed by `Query.asc()` or `Query.desc()`).
    `HistoricProcessInstanceQuery` | `orderByTenantId()` Order by tenant id (needs to be followed by `Query.asc()` or `Query.desc()`).
    `HistoricProcessInstanceQuery` | `processDefinitionCategory(String processDefinitionCategory)` Only select historic process instances whose process definition category is processDefinitionCategory.
    `HistoricProcessInstanceQuery` | `processDefinitionId(String processDefinitionId)` Only select historic process instances for the given process definition
    `HistoricProcessInstanceQuery` | `processDefinitionKey(String processDefinitionKey)` Only select historic process instances that are defined by a process definition with the given key.
    `HistoricProcessInstanceQuery` | `processDefinitionKeyIn(List<String> processDefinitionKeys)` Only select historic process instances that are defined by a process definition with one of the given process definition keys.
    `HistoricProcessInstanceQuery` | `processDefinitionKeyNotIn(List<String> processDefinitionKeys)` Only select historic process instances that don't have a process-definition of which the key is present in the given list
    `HistoricProcessInstanceQuery` | `processDefinitionName(String processDefinitionName)` Select process historic instances whose process definition name is processDefinitionName
    `HistoricProcessInstanceQuery` | `processDefinitionVersion(Integer processDefinitionVersion)` Only select historic process instances with a certain process definition version.
    `HistoricProcessInstanceQuery` | `processInstanceBusinessKey(String processInstanceBusinessKey)` Only select historic process instances with the given business key
    `HistoricProcessInstanceQuery` | `processInstanceId(String processInstanceId)` Only select historic process instances with the given process instance.
    `HistoricProcessInstanceQuery` | `processInstanceIds(Set<String> processInstanceIds)` Only select historic process instances whose id is in the given set of ids.
    `HistoricProcessInstanceQuery` | `processInstanceName(String name)` Only select process instances with the given name.
    `HistoricProcessInstanceQuery` | `processInstanceNameLike(String nameLike)` Only select process instances with a name like the given value.
    `HistoricProcessInstanceQuery` | `processInstanceNameLikeIgnoreCase(String nameLikeIgnoreCase)` Only select process instances with a name like the given value, ignoring upper/lower case.
    `HistoricProcessInstanceQuery` | `processInstanceTenantId(String tenantId)` Only select process instances that have the given tenant id.
    `HistoricProcessInstanceQuery` | `processInstanceTenantIdLike(String tenantIdLike)` Only select process instances with a tenant id like the given one.
    `HistoricProcessInstanceQuery` | `processInstanceWithoutTenantId()` Only select process instances that do not have a tenant id.
    `HistoricProcessInstanceQuery` | `startedAfter(Date date)` Only select historic process instances that were started after the given date.
    `HistoricProcessInstanceQuery` | `startedBefore(Date date)` Only select historic process instances that were started before the given date.
    `HistoricProcessInstanceQuery` | `startedBy(String userId)` Only select historic process instance that are started by the given user.
    `HistoricProcessInstanceQuery` | `superProcessInstanceId(String superProcessInstanceId)` Only select historic process instances started by the given process instance.
    `HistoricProcessInstanceQuery` | `unfinished()` Only select historic process instance that are not yet finished.
    `HistoricProcessInstanceQuery` | `variableValueEquals(Object value)` Only select process instances which had at least one global variable with the given value when they ended.
    `HistoricProcessInstanceQuery` | `variableValueEquals(String name, Object value)` Only select process instances which had a global variable with the given value when they ended.
    `HistoricProcessInstanceQuery` | `variableValueEqualsIgnoreCase(String name, String value)` Only select historic process instances which have a local string variable with the given value, case insensitive.
    `HistoricProcessInstanceQuery` | `variableValueGreaterThan(String name, Object value)` Only select process instances which had a global variable value greater than the passed value when they ended.
    `HistoricProcessInstanceQuery` | `variableValueGreaterThanOrEqual(String name, Object value)` Only select process instances which had a global variable value greater than or equal to the passed value when they ended.
    `HistoricProcessInstanceQuery` | `variableValueLessThan(String name, Object value)` Only select process instances which had a global variable value less than the passed value when the ended.
    `HistoricProcessInstanceQuery` | `variableValueLessThanOrEqual(String name, Object value)` Only select process instances which has a global variable value less than or equal to the passed value when they ended.
    `HistoricProcessInstanceQuery` | `variableValueLike(String name, String value)` Only select process instances which had global variable value like the given value when they ended.
    `HistoricProcessInstanceQuery` | `variableValueLikeIgnoreCase(String name, String value)` Only select process instances which had global variable value like (case insensitive) the given value when they ended.
    `HistoricProcessInstanceQuery` | `variableValueNotEquals(String name, Object value)` Only select process instances which had a global variable with the given name, but with a different value than the passed value when they ended.
    `HistoricProcessInstanceQuery` | `withJobException()` Only select process instances that failed due to an exception happening during a job execution.
    `HistoricProcessInstanceQuery` | `withLocalizationFallback()` Instruct localization to fallback to more general locales including the default locale of the JVM if the specified locale is not found.

    - ### Methods inherited from interface org.activiti.engine.query.Query

      `asc, count, desc, list, listPage, singleResult`

- - ### Method Detail

    - #### processInstanceId

          HistoricProcessInstanceQuery processInstanceId(String processInstanceId)

      Only select historic process instances with the given process instance. ProcessInstance) ids and {@link HistoricProcessInstance} ids match.

    - #### processInstanceIds

          HistoricProcessInstanceQuery processInstanceIds(Set<String> processInstanceIds)

      Only select historic process instances whose id is in the given set of ids. ProcessInstance) ids and {@link HistoricProcessInstance} ids match.

    - #### processDefinitionId

          HistoricProcessInstanceQuery processDefinitionId(String processDefinitionId)

      Only select historic process instances for the given process definition

    - #### processDefinitionKey

          HistoricProcessInstanceQuery processDefinitionKey(String processDefinitionKey)

      Only select historic process instances that are defined by a process definition with the given key.

    - #### processDefinitionKeyIn

          HistoricProcessInstanceQuery processDefinitionKeyIn(List<String> processDefinitionKeys)

      Only select historic process instances that are defined by a process definition with one of the given process definition keys.

    - #### processDefinitionKeyNotIn

          HistoricProcessInstanceQuery processDefinitionKeyNotIn(List<String> processDefinitionKeys)

      Only select historic process instances that don't have a process-definition of which the key is present in the given list

    - #### processDefinitionCategory

          HistoricProcessInstanceQuery processDefinitionCategory(String processDefinitionCategory)

      Only select historic process instances whose process definition category is processDefinitionCategory.

    - #### processDefinitionName

          HistoricProcessInstanceQuery processDefinitionName(String processDefinitionName)

      Select process historic instances whose process definition name is processDefinitionName

    - #### processDefinitionVersion

          HistoricProcessInstanceQuery processDefinitionVersion(Integer processDefinitionVersion)

      Only select historic process instances with a certain process definition version. Particulary useful when used in combination with `processDefinitionKey(String)`

    - #### processInstanceBusinessKey

          HistoricProcessInstanceQuery processInstanceBusinessKey(String processInstanceBusinessKey)

      Only select historic process instances with the given business key

    - #### deploymentId

          HistoricProcessInstanceQuery deploymentId(String deploymentId)

      Only select historic process instances that are defined by a process definition with the given deployment identifier.

    - #### deploymentIdIn

          HistoricProcessInstanceQuery deploymentIdIn(List<String> deploymentIds)

      Only select historic process instances that are defined by a process definition with one of the given deployment identifiers.

    - #### finished

          HistoricProcessInstanceQuery finished()

      Only select historic process instances that are completely finished.

    - #### unfinished

          HistoricProcessInstanceQuery unfinished()

      Only select historic process instance that are not yet finished.

    - #### deleted

          HistoricProcessInstanceQuery deleted()

      Only select historic process instances that are deleted.

    - #### notDeleted

          HistoricProcessInstanceQuery notDeleted()

      Only select historic process instance that are not deleted.

    - #### involvedUser

          HistoricProcessInstanceQuery involvedUser(String userId)

      Only select the historic process instances with which the user with the given id is involved.

    - #### variableValueEquals

          HistoricProcessInstanceQuery variableValueEquals(String name,
                                                           Object value)

      Only select process instances which had a global variable with the given value when they ended. The type only applies to already ended process instances, otherwise use a `ProcessInstanceQuery` instead! of variable is determined based on the value, using types configured in `ProcessEngineConfiguration#getVariableTypes()`. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - of the variable, cannot be null.

    - #### variableValueEquals

          HistoricProcessInstanceQuery variableValueEquals(Object value)

      Only select process instances which had at least one global variable with the given value when they ended. The type only applies to already ended process instances, otherwise use a `ProcessInstanceQuery` instead! of variable is determined based on the value, using types configured in `ProcessEngineConfiguration#getVariableTypes()`. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.

    - #### variableValueEqualsIgnoreCase

          HistoricProcessInstanceQuery variableValueEqualsIgnoreCase(String name,
                                                                     String value)

      Only select historic process instances which have a local string variable with the given value, case insensitive.
      Parameters:
        `name` - name of the variable, cannot be null.
        `value` - value of the variable, cannot be null.

    - #### variableValueNotEquals

          HistoricProcessInstanceQuery variableValueNotEquals(String name,
                                                              Object value)

      Only select process instances which had a global variable with the given name, but with a different value than the passed value when they ended. Only select process instances which have a variable value greater than the passed value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - of the variable, cannot be null.

    - #### variableValueGreaterThan

          HistoricProcessInstanceQuery variableValueGreaterThan(String name,
                                                                Object value)

      Only select process instances which had a global variable value greater than the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported. Only select process instances which have a variable value greater than the passed value.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### variableValueGreaterThanOrEqual

          HistoricProcessInstanceQuery variableValueGreaterThanOrEqual(String name,
                                                                       Object value)

      Only select process instances which had a global variable value greater than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported. Only applies to already ended process instances, otherwise use a `ProcessInstanceQuery` instead!
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### variableValueLessThan

          HistoricProcessInstanceQuery variableValueLessThan(String name,
                                                             Object value)

      Only select process instances which had a global variable value less than the passed value when the ended. Only applies to already ended process instances, otherwise use a `ProcessInstanceQuery` instead! Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### variableValueLessThanOrEqual

          HistoricProcessInstanceQuery variableValueLessThanOrEqual(String name,
                                                                    Object value)

      Only select process instances which has a global variable value less than or equal to the passed value when they ended. Only applies to already ended process instances, otherwise use a `ProcessInstanceQuery` instead! Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null.

    - #### variableValueLike

          HistoricProcessInstanceQuery variableValueLike(String name,
                                                         String value)

      Only select process instances which had global variable value like the given value when they ended. Only applies to already ended process instances, otherwise use a `ProcessInstanceQuery` instead! This can be used on string variables only.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

    - #### variableValueLikeIgnoreCase

          HistoricProcessInstanceQuery variableValueLikeIgnoreCase(String name,
                                                                   String value)

      Only select process instances which had global variable value like (case insensitive) the given value when they ended. Only applies to already ended process instances, otherwise use a `ProcessInstanceQuery` instead! This can be used on string variables only.
      Parameters:
        `name` - cannot be null.
        `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

    - #### startedBefore

          HistoricProcessInstanceQuery startedBefore(Date date)

      Only select historic process instances that were started before the given date.

    - #### startedAfter

          HistoricProcessInstanceQuery startedAfter(Date date)

      Only select historic process instances that were started after the given date.

    - #### finishedBefore

          HistoricProcessInstanceQuery finishedBefore(Date date)

      Only select historic process instances that were started before the given date.

    - #### finishedAfter

          HistoricProcessInstanceQuery finishedAfter(Date date)

      Only select historic process instances that were started after the given date.

    - #### startedBy

          HistoricProcessInstanceQuery startedBy(String userId)

      Only select historic process instance that are started by the given user.

    - #### processInstanceTenantId

          HistoricProcessInstanceQuery processInstanceTenantId(String tenantId)

      Only select process instances that have the given tenant id.

    - #### processInstanceTenantIdLike

          HistoricProcessInstanceQuery processInstanceTenantIdLike(String tenantIdLike)

      Only select process instances with a tenant id like the given one.

    - #### processInstanceWithoutTenantId

          HistoricProcessInstanceQuery processInstanceWithoutTenantId()

      Only select process instances that do not have a tenant id.

    - #### or

          HistoricProcessInstanceQuery or()

      Begin an OR statement. Make sure you invoke the endOr method at the end of your OR statement. Only one OR statement is allowed, for the second call to this method an exception will be thrown.

    - #### endOr

          HistoricProcessInstanceQuery endOr()

      End an OR statement. Only one OR statement is allowed, for the second call to this method an exception will be thrown.

    - #### orderByProcessInstanceId

          HistoricProcessInstanceQuery orderByProcessInstanceId()

      Order by the process instance id (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByProcessDefinitionId

          HistoricProcessInstanceQuery orderByProcessDefinitionId()

      Order by the process definition id (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByProcessInstanceBusinessKey

          HistoricProcessInstanceQuery orderByProcessInstanceBusinessKey()

      Order by the business key (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByProcessInstanceStartTime

          HistoricProcessInstanceQuery orderByProcessInstanceStartTime()

      Order by the start time (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByProcessInstanceEndTime

          HistoricProcessInstanceQuery orderByProcessInstanceEndTime()

      Order by the end time (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByProcessInstanceDuration

          HistoricProcessInstanceQuery orderByProcessInstanceDuration()

      Order by the duration of the process instance (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### orderByTenantId

          HistoricProcessInstanceQuery orderByTenantId()

      Order by tenant id (needs to be followed by `Query.asc()` or `Query.desc()`).

    - #### superProcessInstanceId

          HistoricProcessInstanceQuery superProcessInstanceId(String superProcessInstanceId)

      Only select historic process instances started by the given process instance. ProcessInstance) ids and {@link HistoricProcessInstance} ids match.

    - #### excludeSubprocesses

          HistoricProcessInstanceQuery excludeSubprocesses(boolean excludeSubprocesses)

      Exclude sub processes from the query result;

    - #### includeProcessVariables

          HistoricProcessInstanceQuery includeProcessVariables()

      Include process variables in the process query result

    - #### limitProcessInstanceVariables

          HistoricProcessInstanceQuery limitProcessInstanceVariables(Integer processInstanceVariablesLimit)

      Limit process instance variables

    - #### withJobException

          HistoricProcessInstanceQuery withJobException()

      Only select process instances that failed due to an exception happening during a job execution.

    - #### processInstanceName

          HistoricProcessInstanceQuery processInstanceName(String name)

      Only select process instances with the given name.

    - #### processInstanceNameLike

          HistoricProcessInstanceQuery processInstanceNameLike(String nameLike)

      Only select process instances with a name like the given value.

    - #### processInstanceNameLikeIgnoreCase

          HistoricProcessInstanceQuery processInstanceNameLikeIgnoreCase(String nameLikeIgnoreCase)

      Only select process instances with a name like the given value, ignoring upper/lower case.

    - #### locale

          HistoricProcessInstanceQuery locale(String locale)

      Localize historic process name and description to specified locale.

    - #### withLocalizationFallback

          HistoricProcessInstanceQuery withLocalizationFallback()

      Instruct localization to fallback to more general locales including the default locale of the JVM if the specified locale is not found.

Copyright © 2016 Alfresco. All rights reserved.